/*******************************************************************************
*
*                   Copyright 2003,MARVELL SEMICONDUCTOR ISRAEL, LTD.
* THIS CODE CONTAINS CONFIDENTIAL INFORMATION OF MARVELL.
* NO RIGHTS ARE GRANTED HEREIN UNDER ANY PATENT, MASK WORK RIGHT OR COPYRIGHT
* OF MARVELL OR ANY THIRD PARTY. MARVELL RESERVES THE RIGHT AT ITS SOLE
* DISCRETION TO REQUEST THAT THIS CODE BE IMMEDIATELY RETURNED TO MARVELL.
* THIS CODE IS PROVIDED "AS IS". MARVELL MAKES NO WARRANTIES, EXPRESSED,
* IMPLIED OR OTHERWISE, REGARDING ITS ACCURACY, COMPLETENESS OR PERFORMANCE.
*
* MARVELL COMPRISES MARVELL TECHNOLOGY GROUP LTD. (MTGL) AND ITS SUBSIDIARIES,
* MARVELL INTERNATIONAL LTD. (MIL), MARVELL TECHNOLOGY, INC. (MTI), MARVELL
* SEMICONDUCTOR, INC. (MSI), MARVELL ASIA PTE LTD. (MAPL), MARVELL JAPAN K.K.
* (MJKK), MARVELL SEMICONDUCTOR ISRAEL. (MSIL),  MARVELL TAIWAN, LTD. AND
* SYSKONNECT GMBH.
*
********************************************************************************
* mvBiosIal.h - Header file for BIOS IAL
*
* DESCRIPTION:
*       
*
* DEPENDENCIES:
*
* FILE REVISION NUMBER:
*       $Revision: 1.4 $
*******************************************************************************/
#ifndef __INCmvBiosIalh
#define __INCmvBiosIalh


/* includes */
#include "mvSata.h"
#include <stdarg.h> 

/* Function definitions */
void dummyPrintf(const char *fmt, ...);
void printf(const char *fmt, ...);
int sprintf(char * buf, const char *fmt, ...);

/* Defines */
#define MV_SATA_BIOS_MAX_DRIVES						8
/* Data Structures */
typedef struct
{
    MV_U32          diskSize[MV_SATA_PM_MAX_PORTS];
	MV_BOOLEAN		supportsLBA48Address[MV_SATA_PM_MAX_PORTS];
}SATA_CHANNEL_INFO, *PSATA_CHANNEL_INFO;

typedef struct _HW_ADAPTER_DESCRIPTION
{
	MV_SATA_ADAPTER		mvSataAdapter;	/* CoreDriver Adapter data structure*/
	MV_VOID_PTR			requestsArrayBaseAddr;
	MV_VOID_PTR			requestsArrayBaseAlignedAddr;
	MV_U32				requestsArrayBaseDmaAddr;
	MV_U32				requestsArrayBaseDmaAlignedAddr;
	MV_VOID_PTR			responsesArrayBaseAddr;
	MV_VOID_PTR			responsesArrayBaseAlignedAddr;
	MV_U32				responsesArrayBaseDmaAddr;
	MV_U32				responsesArrayBaseDmaAlignedAddr;
	MV_SATA_CHANNEL		mvSataChannels[MV_SATA_CHANNELS_NUM];
	SATA_CHANNEL_INFO	channelsInfo[MV_SATA_CHANNELS_NUM];
	MV_U8				adapterBusNumber;
	MV_U8				adapterDeviceNumber;
    MV_VOID_PTR			NotificationHandle;
} HW_ADAPTER_DESCRIPTION, *PHW_ADAPTER_DESCRIPTION;

/* Locals */
int vsprintf(char *buf, const char *fmt, va_list args);

#define MV_DEBUG_IAL
#ifdef MV_DEBUG_IAL


#if 0
#define MV_PRINTD printf
#else
#define MV_PRINTD()
#endif

#if 1
#define MV_ERROR printf
#else
#define MV_ERROR()
#endif

#define PRINT() // 		printf

#else
void mvLogMsg printf
#endif


#endif /*__INCmvBiosIalh*/

