#ifndef __INCmvLogh
#define __INCmvLogh

#ifdef __cplusplus
extern "C" /*{*/
#endif /* __cplusplus */

/*-------------H file-----------------------------*/
#define MV_DEBUG_MASK                           0x1
#define MV_DEBUG_INIT_MASK                      0x2
#define MV_DEBUG_INTERRUPTS_MASK                0x4
#define MV_DEBUG_SATA_LINK_MASK                 0x8
#define MV_DEBUG_UDMA_COMMAND_MASK              0x10
#define MV_DEBUG_NON_UDMA_COMMAND_MASK          0x20
#define MV_DEBUG_ERROR_MASK                     0x40
#define MV_DEBUG_PM_MASK                        0x80



#define MV_DEBUG                                0x0
#define MV_DEBUG_INIT                           0x1
#define MV_DEBUG_INTERRUPTS                     0x2
#define MV_DEBUG_SATA_LINK                      0x3
#define MV_DEBUG_UDMA_COMMAND                   0x4
#define MV_DEBUG_NON_UDMA_COMMAND               0x5
#define MV_DEBUG_ERROR                          0x6
#define MV_DEBUG_PM                             0x7



#define MV_MAX_LOG_MODULES         16
#define MV_MAX_MESSAGE_TYPE        8
#define MV_RAW_MSG_ID              0xF

typedef struct 
{    
    MV_BOOLEAN      used;
    MV_U8           filterMask;
    char            *name;
    char            *filters;
} MV_LOG_FILTER_HEADER;


#if defined (MV_LOG_DEBUG) || defined (MV_LOG_ERROR)
#define MV_LOGGER       1
#if defined (WIN32)
ULONG
_cdecl
DbgPrint(
        PCH Format,
        ...
        );
#define MV_LOG_PRINT    DbgPrint
#elif defined (LINUX)
#define MV_LOG_PRINT    printk
#else 
#define MV_LOG_PRINT	printf
#endif


MV_BOOLEAN mvLogRegisterModule(MV_U8 moduleId, MV_U8 filterMask, char* name);
MV_BOOLEAN mvLogSetModuleFilter(MV_U8 moduleId, MV_U8 filterMask);
MV_U8 mvLogGetModuleFilter(MV_U8 moduleId);
void mvLogMsg(MV_U8 moduleId, MV_U8 type, char* format, ...);

#else /*defined (MV_LOG_DEBUG) || defined (MV_LOG_ERROR)*/

#undef MV_LOGGER

#if defined (WIN32)
#define MV_LOG_PRINT
#define mvLogRegisterModule
#define mvLogGetModuleFilter
#define mvLogRegisterAllModules
#define mvLogMsg

#elif defined (LINUX)
#define MV_LOG_PRINT(x...)
#define mvLogRegisterModule(x...)
#define mvLogSetModuleFilter(x...)
#define mvLogGetModuleFilter(x...)
#define mvLogRegisterAllModules(x...)
#define mvLogMsg(x...)

#else 
#define MV_LOG_PRINT
#define mvLogRegisterModule
#define mvLogSetModuleFilter
#define mvLogGetModuleFilter
#define mvLogRegisterAllModules
#define mvLogMsg
#endif

#endif /*!defined (MV_LOG_DEBUG) && !defined (MV_LOG_ERROR)*/

#ifdef __cplusplus
/*}*/
#endif /* __cplusplus */

#endif

