/*******************************************************************************
Copyright (C) Marvell International Ltd. and its affiliates

This software file (the "File") is owned and distributed by Marvell 
International Ltd. and/or its affiliates ("Marvell") under the following
alternative licensing terms.  Once you have made an election to distribute the
File under one of the following license alternatives, please (i) delete this
introductory statement regarding license alternatives, (ii) delete the two
license alternatives that you have not elected to use and (iii) preserve the
Marvell copyright notice above.

********************************************************************************
Marvell Commercial License Option

If you received this File from Marvell and you have entered into a commercial
license agreement (a "Commercial License") with Marvell, the File is licensed
to you under the terms of the applicable Commercial License.

********************************************************************************
Marvell GPL License Option

If you received this File from Marvell, you may opt to use, redistribute and/or 
modify this File in accordance with the terms and conditions of the General 
Public License Version 2, June 1991 (the "GPL License"), a copy of which is 
available along with the File in the license.txt file or by writing to the Free 
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 or 
on the worldwide web at http://www.gnu.org/licenses/gpl.txt. 

THE FILE IS DISTRIBUTED AS-IS, WITHOUT WARRANTY OF ANY KIND, AND THE IMPLIED 
WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY 
DISCLAIMED.  The GPL License provides additional details about this warranty 
disclaimer.
********************************************************************************
Marvell BSD License Option

If you received this File from Marvell, you may opt to use, redistribute and/or 
modify this File under the following licensing terms. 
Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

    *   Redistributions of source code must retain the above copyright notice,
	    this list of conditions and the following disclaimer. 

    *   Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution. 

    *   Neither the name of Marvell nor the names of its contributors may be 
        used to endorse or promote products derived from this software without 
        specific prior written permission. 
    
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR 
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*******************************************************************************/
/*******************************************************************************
* mvSataUserApi.h - Header file for GUI IO Controls definition
*
* DESCRIPTION:
*       None.
*
* DEPENDENCIES:
*
*******************************************************************************/
#ifndef _MVSATAUSERAPI_H
#define _MVSATAUSERAPI_H

#define MV_IOCTL_VERSION2_SIGNATURE           "VRSN_2_1"
#define MV_IOCTL_VERSION2_SIGNATURE_LENGTH    8

#ifndef MV_U32
typedef unsigned long MV_U32;
#endif
#ifndef MV_U16
typedef unsigned short MV_U16;
#endif
#ifndef MV_U8
typedef unsigned char MV_U8;
#endif

#define MV_SATA_MAX_DEBUG_LEVELS	10
#define MV_SATA_MAX_DEBUGEE_MODULES 10

#if 0

#ifndef MV_STORAGE_DEVICE_REGISTERS

typedef struct mvStorageDevRegisters 
{
    MV_U8    errorRegister;
    MV_U16   featuresRegister;/*input only*/
    MV_U8    commandRegister;/*input only*/
    MV_U16   sectorCountRegister;
    MV_U16   lbaLowRegister;
    MV_U16   lbaMidRegister;
    MV_U16   lbaHighRegister;
    MV_U8    deviceRegister;
    MV_U8    statusRegister;
} MV_STORAGE_DEVICE_REGISTERS;
#endif
#endif

/*********************************************************
************** Adapter query control codes ***************
**********************************************************/

#define MV_ADAPTER_MSG                          0xface0000 /* Message to adapter*/
#define MV_ADAPTER_MSG_READ_REGISTER            0x00010000 /* Read register */
typedef struct mvAdapterMsgReadRegister
{
    /* User space */
    MV_U32  control; /*0x00010000 */
    MV_U32  regAddr; /* Register Address */
    /* Driver */
    MV_U32  result;  /* Result */
}   MV_ADAPTER_MSG_READ_REGISTER_STRUCT;

#define MV_ADAPTER_MSG_WRITE_REGISTER           0x00010001 /* Write register */
typedef struct mvAdapterMsgWriteRegister
{
    /* User space */
    MV_U32  control; /*0x00010001 */
    MV_U32  regAddr; /* Register Address */
    MV_U32  result;  /* Result */
    /* Driver */
}   MV_ADAPTER_MSG_WRITE_REGISTER_STRUCT;


/*********************************************************
************** Storage device control codes **************
**********************************************************/
#define MV_DEVICE_MSG                           0xface0001 /* Message to device */
#define MV_DEVICE_MSG_PIO_COMMAND               0x00020000 /* Perform PIO command */
typedef struct mvDeviceMsgQueuePioCommand
{
    /* User space */
    MV_U32  control; /*0x00020000*/
    MV_U32  channelIndex;
    MV_U32  PMPort;
    MV_U32  protocolType;
    MV_U32  isExt; /* 0 no, 1 yes */
    MV_U32  bufferSize;
    MV_STORAGE_DEVICE_REGISTERS sataRegs; /* Input to driver, output for results */
    MV_U32  bufferStart; /* This buffer as input to driver when PIO data-out
                       and as output to the driver when PIO data-in */
} MV_DEVICE_MSG_QUEUE_PIO_COMMAND_STRUCT;


/*********************************************************
************** Driver control codes **********************
**********************************************************/
#define MV_DRIVER_MSG                           0xface0002 /* Message to device */
#define MV_DRIVER_MSG_GET_PCI_ATTR              0x00030000 /* Get PCI attributres */

typedef struct mvDriverMsgGetPciAttr
{
    /* User space */
    MV_U32  control; /*0x00030000*/
    /* Driver */
    MV_U32  pciBusNum;
    MV_U32  pciDevFuncNum;
    MV_U32  COREDriverInstanceId;
	MV_U32	deviceId;
	MV_U32	revId;
	MV_U32  baseAddress;
    MV_U32	attachedDrives[8];
	MV_U32	queueDepth[8];
} MV_DRIVER_MSG_GET_PCI_ATTR_STRUCT;
#define	MV_DRIVER_MSG_GET_STATS					0x00030001 /* Get adapter statistics */
typedef struct storageDevicesStats
{
	MV_U32 channelIndex; /* 0xffffffff in channel not available */
	MV_U32 pmVector;
	MV_U32 totalAccumulatedOutstanding;
	MV_U32 totalIosPerPmPort[MV_SATA_PM_MAX_PORTS];
	MV_U32 totalSectorsPerPmPort[MV_SATA_PM_MAX_PORTS];
} STORAGE_DEVICES_STATS;

typedef struct mvDriverMsgGetStatsStruct
{
	/* User space */
	MV_U32	control; /*0x00030001*/
	/* Driver */
	MV_U32	currentTimeLo; /* currentTime in mSec resolution */
	MV_U32	currentTimeHi; /* currentTime in mSec resolution */
	STORAGE_DEVICES_STATS channelStats[8];
} MV_DRIVER_MSG_GET_STATS_STRUCT;

#define	MV_DRIVER_MSG_GET_DEBUG_FILTERS			0x00030002 /* Gets all debug filter (mvLog.c) */
typedef struct mvDriverMsgGetDebugFiltersStruct
{
	/* User space */
	MV_U32	control; /*0x00030002*/
	/* Driver */
	MV_U32  numOfDebugLevels; /* Up to 10 levels */
	MV_U32  numOfDebugeeModules; /* Up to 10 debugee modules */
	MV_U8	debugLevelsNames[MV_SATA_MAX_DEBUG_LEVELS][40]; /* Up to 40 characters per debug level */
	MV_U32	debugLevelsFilterVector[MV_SATA_MAX_DEBUGEE_MODULES];
	MV_U8	debugeeModules[MV_SATA_MAX_DEBUGEE_MODULES][40]; /* Up to 40 characters per debugee level */
} MV_DRIVER_MSG_GET_DEBUG_FILTERS_STRUCT;

#define	MV_DRIVER_MSG_SET_MODULE_DEBUG_FILTER			0x00030003 /* Gets all debug filter (mvLog.c) */
typedef struct mvDriverMsgSetModuleDebugFilterStruct
{
	/* User space */
	MV_U32	control; /*0x00030003*/
	MV_U32	moduleNum;
	MV_U32	filterVector;
	/* Driver */
} MV_DRIVER_MSG_SET_MODULE_DEBUG_FILTER_STRUCT;

#define	MV_DRIVER_MSG_DISABLE_QUEUING					0x00030004 /* Enables/Disables queuing */
typedef struct mvDriverMsgDisableQueuingStruct
{
	/* User space */
	MV_U32	control; /*0x00030004*/
	MV_U32	channelIndex;
	MV_U32	onOff_; /* 1 queuing is not permitted, 0 queuing is permitted */
	/* Driver */
} MV_DRIVER_MSG_DISABLE_QUEUING_STRUCT;

#define	MV_DRIVER_MSG_MODIFY_QUEUE_DEPTH				0x00030005 /* Modifies channel's queue depth */
typedef struct mvDriverMsgModifyQueueDepthStruct
{
	/* User space */
	MV_U32	control; /*0x00030005*/
	MV_U32	channelIndex;
	MV_U32	queueDepth;
	/* Driver */
} MV_DRIVER_MSG_MODIFY_QUEUE_DEPTH_STRUCT;

#endif /* _MVSATAUSERAPI_H */

